/* //////////////////////////////////////////////////////////////////////////////

						Exemple d'utilisation des flux

			 pour la lecture et l'criture de fichiers texte et binaire

   ////////////////////////////////////////////////////////////////////////////// */

#include <stdio.h>
#include <assert.h>

#define N	100
#define L	40


/* ////////////////////////////////////////
			Dclarations des types
   //////////////////////////////////////// */
typedef struct
{
	int a;
	float x;
	char s[L];
} ELEMENT;


/* ////////////////////////////////////////
	Dclarations des variables constantes
   //////////////////////////////////////// */
const char SOURCE1[] = "Texte1.txt";
const char CIBLE1[]  = "Binaire.bin";

const char *SOURCE2 = CIBLE1;
const char CIBLE2[]  = "Texte2.txt";


/* ////////////////////////////////////////
				 Prototypes
   //////////////////////////////////////// */
void lireTexte(ELEMENT[], int *);
void lireBinaire(ELEMENT[], int *);
void ecrireTexte(ELEMENT[], int);
void ecrireBinaire(ELEMENT[], int);
void traiter(ELEMENT[], int);


/* ////////////////////////////////////////
			 Programme principal
   //////////////////////////////////////// */
int main()
{
	ELEMENT tab[N];
	int n;

	lireTexte(tab,&n);
	traiter(tab,n);
	ecrireBinaire(tab,n);

	lireBinaire(tab,&n);
	traiter(tab,n);
	ecrireTexte(tab,n);

	return 0;
}


/* ////////////////////////////////////////
				  Fonctions
   //////////////////////////////////////// */
void lireTexte(ELEMENT tab[], int *nb)
{
	int i;
	FILE *f;

	f = fopen(SOURCE1, "r"); assert(f != NULL);

	i = 0;
	while( fscanf(f,"%d %f %s\n", &tab[i].a, &tab[i].x, &tab[i].s) == 3 )
	{
		i++;
		assert(i < N);
	}
	fclose(f);
	*nb = i;
}

void ecrireBinaire(ELEMENT tab[], int nb)
{
	FILE *f;

	f = fopen(CIBLE1,"w"); assert(f != NULL);
	fwrite (tab, sizeof(ELEMENT), nb, f);
	fclose(f);
}

void lireBinaire(ELEMENT tab[], int *nb)
{
	int i;
	FILE *f;

	f = fopen(SOURCE2, "r"); assert(f != NULL);

	i = 0;
	while( fread(&tab[i], sizeof(ELEMENT), 1, f) == 1 )
	{
		i++;
		assert(i < N);
	}
	fclose(f);
	*nb = i;
}

void ecrireTexte(ELEMENT tab[], int nb)
{
	int i;
	FILE *f;

	f = fopen(CIBLE2,"w"); assert(f != NULL);
	
	for (i = 0; i < nb; i++)
	{
		fprintf(f,"%d %f %s\n", tab[i].a, tab[i].x, tab[i].s);
	}
	fclose(f);
}

void traiter(ELEMENT tab[], int nb)
{
	/* traitement quelconque */
}

